#!/usr/bin/perl -w
#This is an exemplary perl script that was created for the usage in Linux 2.6.32-642.el6.x86_64 x86_64
#the output of createclustertable.frm is translated into a FORM procedure that can be used in EoM_main.frm
#
#the script is started like this from the command line: ./createclustertable.pl file 4
#file in this example is the output of createclustertable.frm and 4 the Photon Correlations (PHC)
#declaration of file names uses command line arguments
my @inputfile = ($ARGV[0]);
my $PHC = ($ARGV[1]);
my $outpufile="expectationvaluetableQDC1PhC".$PHC.".prc";

foreach $path (@inputfile) {
# open inputfile and copy the data into inputdata
open (DATEI, "$path") || die ("could not open \"$path\" .error: $!");
@inputdata = <DATEI>;
close DATEI;

my $i=0,$string1='',$string2='',$string3='',$anfang=0,$counter=0;

#remove line breaks:
foreach (@inputdata) {
	if( $inputdata[$i]=~/sec/){$anfang=0;}
	#Testing				
	if($anfang==1){$counter++}
	if($anfang==1&&$counter>0){
	$string1=$string1.$inputdata[$i];
	chomp ($string1);
	}
	if($inputdata[$i]=~/\.end/){
		$anfang=1;
		$counter++;
	}
$i++;
}
$string1=~ s/\015\012|\015|\012/\n/g;
$string1=~ s/\n//g;

#remove N(0) equations
$string1=~ s/\[N\]\(0\)\,//g;
#remove spaces
$string1=~ s/ //g;
#introduce line breaks after every ;  
$string1=~ s/(.+?\;)/ $1 \n /g;
#remove equations that are zero
$string1=~ s/\[.+?\=0\;//g;
#remove line breaks and spaces
$string1=~ s/ //g;
$string1=~ s/\n//g;
#introduce 2 line breaks after every ;
$string1=~ s/(.+?\;)/$1\n\n/g;

#replace indices by indices wild card
for($a=0;$a<10;$a++){
$string1=~ s/\[id(.+?)([ijklmnopq])\,(.+?)\]\=/[id$1$2?,$3]=/g;
$string1=~ s/\[id(.+?)([ijklmnopq])\)(.+?)\]\=/[id$1$2?)$3]=/g;
$string1=~ s/\[id(.+?)\(([uvwxyz])\)(.+?)\]\=/[id$1?bose(?$2)$3]=/g;
}
$string1=~ s/\(([uvwxyz])\)/(?$1)/g;
$string1=~ s/\[idev/id ev/g;
$string1=~ s/\]\=/=/g;

#remove N0
$string1=~ s/N0\,//g;
#replace N1..NX with [b+],...,[b]
my $string0='';
$string1=~ s/N1/[b+],[b]/g;
$string1=~ s/N2/[b+],[b+],[b],[b]/g; 
$string1=~ s/N3/[b+],[b+],[b+],[b],[b],[b]/g; 
$string1=~ s/N4/[b+],[b+],[b+],[b+],[b],[b],[b],[b]/g; 
$string1=~ s/N5/[b+],[b+],[b+],[b+],[b+],[b],[b],[b],[b],[b]/g; 
$string1=~ s/N6/[b+],[b+],[b+],[b+],[b+],[b+],[b],[b],[b],[b],[b],[b]/g; 
$string2="#procedure expectationvaluetableQDC1PhC".$PHC."\n";
$string3="#endprocedure";


#open file for output
open (OUT, ">$outpufile") || die ("konnte die Datei \"outpufile\" nicht öffnen. Fehler: $!");
#write data into outpufile
print OUT $string2;
print OUT $string1;
print OUT $string3;
close OUT;

}
