#procedure expectationvaluetableQDC1PhC6
***input:					
***output:	sum of products of expectation values containing maximum number of operators as declared by QDC and PhC
***		ev([b+],[b+],[b],[Q](i,j,k),[Q](l,m,n))->sum ev([b+],[b],[Q](i,j,k))*ev([b+],[Q](l,m,n))
***local state:	non factorized expectation values of operators divided by commas


id ev([Q](i?,j?,k?))=+ev([Q](i,j,k));

id ev([b+],[Q](i?,j?,k?))=+ev([b+],[Q](i,j,k));

id ev([b],[Q](i?,j?,k?))=+ev([b],[Q](i,j,k));

id ev([b+],[b],[Q](i?,j?,k?))=+ev([b+],[b],[Q](i,j,k));

id ev([b+],[b+],[b],[Q](i?,j?,k?))=+ev([b+],[b+],[b],[Q](i,j,k));

id ev([b+],[b],[b],[Q](i?,j?,k?))=+ev([b+],[b],[b],[Q](i,j,k));

id ev([b+],[b+],[b],[b],[Q](i?,j?,k?))=+ev([b+],[b+],[b],[b],[Q](i,j,k));

id ev([b+],[b+],[b+],[b],[b],[Q](i?,j?,k?))=+ev([b+],[b+],[b+],[b],[b],[Q](i,j,k));

id ev([b+],[b+],[b],[b],[b],[Q](i?,j?,k?))=+ev([b+],[b+],[b],[b],[b],[Q](i,j,k));

id ev([b+],[b+],[b+],[b],[b],[b],[Q](i?,j?,k?))=+ev([b+],[b+],[b+],[b],[b],[b])*ev([Q](i,j,k))-18*ev([b+],[b])*ev([b+],[b+],[b],[b])*ev([Q](i,j,k))+9*ev([b+],[b])*ev([b+],[b+],[b],[b],[Q](i,j,k))+36*ev([b+],[b])^3*ev([Q](i,j,k))-36*ev([b+],[b])^2*ev([b+],[b],[Q](i,j,k))+9*ev([b+],[b],[Q](i,j,k))*ev([b+],[b+],[b],[b]);

id ev([b+],[b+],[b+],[b+],[b],[b],[b],[Q](i?,j?,k?))=+4*ev([b+],[b+],[b+],[b],[b],[b])*ev([b+],[Q](i,j,k))+18*ev([b+],[b+],[b],[b])*ev([b+],[b+],[b],[Q](i,j,k))+12*ev([b+],[b])*ev([b+],[b+],[b+],[b],[b],[Q](i,j,k))-72*ev([b+],[b])*ev([b+],[b+],[b],[b])*ev([b+],[Q](i,j,k))-72*ev([b+],[b])^2*ev([b+],[b+],[b],[Q](i,j,k))+144*ev([b+],[b])^3*ev([b+],[Q](i,j,k));

id ev([b+],[b+],[b+],[b],[b],[b],[b],[Q](i?,j?,k?))=+12*ev([b+],[b])*ev([b+],[b+],[b],[b],[b],[Q](i,j,k))-72*ev([b+],[b])^2*ev([b+],[b],[b],[Q](i,j,k))+18*ev([b+],[b],[b],[Q](i,j,k))*ev([b+],[b+],[b],[b])+4*ev([b],[Q](i,j,k))*ev([b+],[b+],[b+],[b],[b],[b])-72*ev([b],[Q](i,j,k))*ev([b+],[b])*ev([b+],[b+],[b],[b])+144*ev([b],[Q](i,j,k))*ev([b+],[b])^3;

id ev([Q](i?,j?,k?),[Q](l?,m?,n?))=+ev([Q](i,j,k))*ev([Q](l,m,n));

id ev([b+],[Q](i?,j?,k?),[Q](l?,m?,n?))=+ev([b+],[Q](i,j,k))*ev([Q](l,m,n))+ev([b+],[Q](l,m,n))*ev([Q](i,j,k));

id ev([b],[Q](i?,j?,k?),[Q](l?,m?,n?))=+ev([b],[Q](i,j,k))*ev([Q](l,m,n))+ev([b],[Q](l,m,n))*ev([Q](i,j,k));

id ev([b+],[b+],[Q](i?,j?,k?))=+ev([b+],[b+],[Q](i,j,k));

id ev([b],[b],[Q](i?,j?,k?))=+ev([b],[b],[Q](i,j,k));

id ev([b+],[b],[Q](i?,j?,k?),[Q](l?,m?,n?))=-ev([b+],[b])*ev([Q](i,j,k))*ev([Q](l,m,n))+ev([b+],[b],[Q](i,j,k))*ev([Q](l,m,n))+ev([b+],[b],[Q](l,m,n))*ev([Q](i,j,k))+ev([b],[Q](i,j,k))*ev([b+],[Q](l,m,n))+ev([b],[Q](l,m,n))*ev([b+],[Q](i,j,k));

id ev([b+],[b+],[b],[Q](i?,j?,k?),[Q](l?,m?,n?))=+ev([b+],[b+],[b],[Q](i,j,k))*ev([Q](l,m,n))+ev([b+],[b+],[b],[Q](l,m,n))*ev([Q](i,j,k))-2*ev([b+],[b])*ev([b+],[Q](i,j,k))*ev([Q](l,m,n))-2*ev([b+],[b])*ev([b+],[Q](l,m,n))*ev([Q](i,j,k))+2*ev([b+],[b],[Q](i,j,k))*ev([b+],[Q](l,m,n))+2*ev([b+],[b],[Q](l,m,n))*ev([b+],[Q](i,j,k))+ev([b],[Q](i,j,k))*ev([b+],[b+],[Q](l,m,n))+ev([b],[Q](l,m,n))*ev([b+],[b+],[Q](i,j,k));

id ev([b+],[b],[b],[Q](i?,j?,k?),[Q](l?,m?,n?))=+ev([b+],[b],[b],[Q](i,j,k))*ev([Q](l,m,n))+ev([b+],[b],[b],[Q](l,m,n))*ev([Q](i,j,k))-2*ev([b],[Q](i,j,k))*ev([b+],[b])*ev([Q](l,m,n))+2*ev([b],[Q](i,j,k))*ev([b+],[b],[Q](l,m,n))-2*ev([b],[Q](l,m,n))*ev([b+],[b])*ev([Q](i,j,k))+2*ev([b],[Q](l,m,n))*ev([b+],[b],[Q](i,j,k))+ev([b],[b],[Q](i,j,k))*ev([b+],[Q](l,m,n))+ev([b],[b],[Q](l,m,n))*ev([b+],[Q](i,j,k));

id ev([b+],[b+],[b+],[b],[Q](i?,j?,k?))=+ev([b+],[b+],[b+],[b],[Q](i,j,k));

id ev([b+],[b],[b],[b],[Q](i?,j?,k?))=+ev([b+],[b],[b],[b],[Q](i,j,k));

id ev([b+],[b+],[b],[b],[Q](i?,j?,k?),[Q](l?,m?,n?))=-ev([b+],[b+],[b],[b])*ev([Q](i,j,k))*ev([Q](l,m,n))+ev([b+],[b+],[b],[b],[Q](i,j,k))*ev([Q](l,m,n))+ev([b+],[b+],[b],[b],[Q](l,m,n))*ev([Q](i,j,k))+4*ev([b+],[b])^2*ev([Q](i,j,k))*ev([Q](l,m,n))-4*ev([b+],[b])*ev([b+],[b],[Q](i,j,k))*ev([Q](l,m,n))-4*ev([b+],[b])*ev([b+],[b],[Q](l,m,n))*ev([Q](i,j,k))+4*ev([b+],[b],[Q](i,j,k))*ev([b+],[b],[Q](l,m,n))+2*ev([b+],[b],[b],[Q](i,j,k))*ev([b+],[Q](l,m,n))+2*ev([b+],[b],[b],[Q](l,m,n))*ev([b+],[Q](i,j,k))+2*ev([b],[Q](i,j,k))*ev([b+],[b+],[b],[Q](l,m,n))-4*ev([b],[Q](i,j,k))*ev([b+],[b])*ev([b+],[Q](l,m,n))+2*ev([b],[Q](l,m,n))*ev([b+],[b+],[b],[Q](i,j,k))-4*ev([b],[Q](l,m,n))*ev([b+],[b])*ev([b+],[Q](i,j,k))+ev([b],[b],[Q](i,j,k))*ev([b+],[b+],[Q](l,m,n))+ev([b],[b],[Q](l,m,n))*ev([b+],[b+],[Q](i,j,k));

id ev([b+],[b+],[b+],[b],[b],[Q](i?,j?,k?),[Q](l?,m?,n?))=+ev([b+],[b+],[b+],[b],[b],[Q](i,j,k))*ev([Q](l,m,n))+ev([b+],[b+],[b+],[b],[b],[Q](l,m,n))*ev([Q](i,j,k))-3*ev([b+],[b+],[b],[b])*ev([b+],[Q](i,j,k))*ev([Q](l,m,n))-3*ev([b+],[b+],[b],[b])*ev([b+],[Q](l,m,n))*ev([Q](i,j,k))+3*ev([b+],[b+],[b],[b],[Q](i,j,k))*ev([b+],[Q](l,m,n))+3*ev([b+],[b+],[b],[b],[Q](l,m,n))*ev([b+],[Q](i,j,k))-6*ev([b+],[b])*ev([b+],[b+],[b],[Q](i,j,k))*ev([Q](l,m,n))-6*ev([b+],[b])*ev([b+],[b+],[b],[Q](l,m,n))*ev([Q](i,j,k))+12*ev([b+],[b])^2*ev([b+],[Q](i,j,k))*ev([Q](l,m,n))+12*ev([b+],[b])^2*ev([b+],[Q](l,m,n))*ev([Q](i,j,k))-12*ev([b+],[b])*ev([b+],[b],[Q](i,j,k))*ev([b+],[Q](l,m,n))-12*ev([b+],[b])*ev([b+],[b],[Q](l,m,n))*ev([b+],[Q](i,j,k))+6*ev([b+],[b],[Q](i,j,k))*ev([b+],[b+],[b],[Q](l,m,n))+6*ev([b+],[b],[Q](l,m,n))*ev([b+],[b+],[b],[Q](i,j,k))+3*ev([b+],[b],[b],[Q](i,j,k))*ev([b+],[b+],[Q](l,m,n))+3*ev([b+],[b],[b],[Q](l,m,n))*ev([b+],[b+],[Q](i,j,k))+2*ev([b],[Q](i,j,k))*ev([b+],[b+],[b+],[b],[Q](l,m,n))-6*ev([b],[Q](i,j,k))*ev([b+],[b])*ev([b+],[b+],[Q](l,m,n))+2*ev([b],[Q](l,m,n))*ev([b+],[b+],[b+],[b],[Q](i,j,k))-6*ev([b],[Q](l,m,n))*ev([b+],[b])*ev([b+],[b+],[Q](i,j,k))+ev([b],[b],[Q](i,j,k))*ev([b+],[b+],[b+],[Q](l,m,n))+ev([b],[b],[Q](l,m,n))*ev([b+],[b+],[b+],[Q](i,j,k));

id ev([b+],[b+],[b],[b],[b],[Q](i?,j?,k?),[Q](l?,m?,n?))=+ev([b+],[b+],[b],[b],[b],[Q](i,j,k))*ev([Q](l,m,n))+ev([b+],[b+],[b],[b],[b],[Q](l,m,n))*ev([Q](i,j,k))-6*ev([b+],[b])*ev([b+],[b],[b],[Q](i,j,k))*ev([Q](l,m,n))-6*ev([b+],[b])*ev([b+],[b],[b],[Q](l,m,n))*ev([Q](i,j,k))+6*ev([b+],[b],[b],[Q](i,j,k))*ev([b+],[b],[Q](l,m,n))+6*ev([b+],[b],[b],[Q](l,m,n))*ev([b+],[b],[Q](i,j,k))+2*ev([b+],[b],[b],[b],[Q](i,j,k))*ev([b+],[Q](l,m,n))+2*ev([b+],[b],[b],[b],[Q](l,m,n))*ev([b+],[Q](i,j,k))-3*ev([b],[Q](i,j,k))*ev([b+],[b+],[b],[b])*ev([Q](l,m,n))+3*ev([b],[Q](i,j,k))*ev([b+],[b+],[b],[b],[Q](l,m,n))+12*ev([b],[Q](i,j,k))*ev([b+],[b])^2*ev([Q](l,m,n))-12*ev([b],[Q](i,j,k))*ev([b+],[b])*ev([b+],[b],[Q](l,m,n))-3*ev([b],[Q](l,m,n))*ev([b+],[b+],[b],[b])*ev([Q](i,j,k))+3*ev([b],[Q](l,m,n))*ev([b+],[b+],[b],[b],[Q](i,j,k))+12*ev([b],[Q](l,m,n))*ev([b+],[b])^2*ev([Q](i,j,k))-12*ev([b],[Q](l,m,n))*ev([b+],[b])*ev([b+],[b],[Q](i,j,k))+3*ev([b],[b],[Q](i,j,k))*ev([b+],[b+],[b],[Q](l,m,n))-6*ev([b],[b],[Q](i,j,k))*ev([b+],[b])*ev([b+],[Q](l,m,n))+3*ev([b],[b],[Q](l,m,n))*ev([b+],[b+],[b],[Q](i,j,k))-6*ev([b],[b],[Q](l,m,n))*ev([b+],[b])*ev([b+],[Q](i,j,k))+ev([b],[b],[b],[Q](i,j,k))*ev([b+],[b+],[Q](l,m,n))+ev([b],[b],[b],[Q](l,m,n))*ev([b+],[b+],[Q](i,j,k));

id ev([b+],[b+],[b+],[b+],[b],[b],[Q](i?,j?,k?))=+6*ev([b+],[b+],[b],[b])*ev([b+],[b+],[Q](i,j,k))+8*ev([b+],[b])*ev([b+],[b+],[b+],[b],[Q](i,j,k))-24*ev([b+],[b])^2*ev([b+],[b+],[Q](i,j,k));

id ev([b+],[b+],[b],[b],[b],[b],[Q](i?,j?,k?))=+8*ev([b+],[b])*ev([b+],[b],[b],[b],[Q](i,j,k))+6*ev([b],[b],[Q](i,j,k))*ev([b+],[b+],[b],[b])-24*ev([b],[b],[Q](i,j,k))*ev([b+],[b])^2;

id ev([b+],[b+],[Q](i?,j?,k?),[Q](l?,m?,n?))=+2*ev([b+],[Q](i,j,k))*ev([b+],[Q](l,m,n))+ev([b+],[b+],[Q](i,j,k))*ev([Q](l,m,n))+ev([b+],[b+],[Q](l,m,n))*ev([Q](i,j,k));

id ev([b+],[b+],[b+],[Q](i?,j?,k?),[Q](l?,m?,n?))=+3*ev([b+],[b+],[Q](i,j,k))*ev([b+],[Q](l,m,n))+3*ev([b+],[b+],[Q](l,m,n))*ev([b+],[Q](i,j,k))+ev([b+],[b+],[b+],[Q](i,j,k))*ev([Q](l,m,n))+ev([b+],[b+],[b+],[Q](l,m,n))*ev([Q](i,j,k));

id ev([b],[b],[Q](i?,j?,k?),[Q](l?,m?,n?))=+2*ev([b],[Q](i,j,k))*ev([b],[Q](l,m,n))+ev([b],[b],[Q](i,j,k))*ev([Q](l,m,n))+ev([b],[b],[Q](l,m,n))*ev([Q](i,j,k));

id ev([b],[b],[b],[Q](i?,j?,k?),[Q](l?,m?,n?))=+3*ev([b],[b],[Q](i,j,k))*ev([b],[Q](l,m,n))+3*ev([b],[b],[Q](l,m,n))*ev([b],[Q](i,j,k))+ev([b],[b],[b],[Q](i,j,k))*ev([Q](l,m,n))+ev([b],[b],[b],[Q](l,m,n))*ev([Q](i,j,k));

id ev([b+],[b+],[b+],[b],[Q](i?,j?,k?),[Q](l?,m?,n?))=+ev([b+],[b+],[b+],[b],[Q](i,j,k))*ev([Q](l,m,n))+ev([b+],[b+],[b+],[b],[Q](l,m,n))*ev([Q](i,j,k))+3*ev([b+],[b+],[b],[Q](i,j,k))*ev([b+],[Q](l,m,n))+3*ev([b+],[b+],[b],[Q](l,m,n))*ev([b+],[Q](i,j,k))-6*ev([b+],[b])*ev([b+],[Q](i,j,k))*ev([b+],[Q](l,m,n))-3*ev([b+],[b])*ev([b+],[b+],[Q](i,j,k))*ev([Q](l,m,n))-3*ev([b+],[b])*ev([b+],[b+],[Q](l,m,n))*ev([Q](i,j,k))+3*ev([b+],[b],[Q](i,j,k))*ev([b+],[b+],[Q](l,m,n))+3*ev([b+],[b],[Q](l,m,n))*ev([b+],[b+],[Q](i,j,k))+ev([b],[Q](i,j,k))*ev([b+],[b+],[b+],[Q](l,m,n))+ev([b],[Q](l,m,n))*ev([b+],[b+],[b+],[Q](i,j,k));

id ev([b+],[b+],[b+],[b+],[b],[Q](i?,j?,k?),[Q](l?,m?,n?))=+ev([b+],[b+],[b+],[b+],[b],[Q](i,j,k))*ev([Q](l,m,n))+ev([b+],[b+],[b+],[b+],[b],[Q](l,m,n))*ev([Q](i,j,k))+4*ev([b+],[b+],[b+],[b],[Q](i,j,k))*ev([b+],[Q](l,m,n))+4*ev([b+],[b+],[b+],[b],[Q](l,m,n))*ev([b+],[Q](i,j,k))+6*ev([b+],[b+],[b],[Q](i,j,k))*ev([b+],[b+],[Q](l,m,n))+6*ev([b+],[b+],[b],[Q](l,m,n))*ev([b+],[b+],[Q](i,j,k))-12*ev([b+],[b])*ev([b+],[b+],[Q](i,j,k))*ev([b+],[Q](l,m,n))-12*ev([b+],[b])*ev([b+],[b+],[Q](l,m,n))*ev([b+],[Q](i,j,k))-4*ev([b+],[b])*ev([b+],[b+],[b+],[Q](i,j,k))*ev([Q](l,m,n))-4*ev([b+],[b])*ev([b+],[b+],[b+],[Q](l,m,n))*ev([Q](i,j,k))+4*ev([b+],[b],[Q](i,j,k))*ev([b+],[b+],[b+],[Q](l,m,n))+4*ev([b+],[b],[Q](l,m,n))*ev([b+],[b+],[b+],[Q](i,j,k))+ev([b],[Q](i,j,k))*ev([b+],[b+],[b+],[b+],[Q](l,m,n))+ev([b],[Q](l,m,n))*ev([b+],[b+],[b+],[b+],[Q](i,j,k));

id ev([b+],[b],[b],[b],[Q](i?,j?,k?),[Q](l?,m?,n?))=+ev([b+],[b],[b],[b],[Q](i,j,k))*ev([Q](l,m,n))+ev([b+],[b],[b],[b],[Q](l,m,n))*ev([Q](i,j,k))+3*ev([b],[Q](i,j,k))*ev([b+],[b],[b],[Q](l,m,n))-6*ev([b],[Q](i,j,k))*ev([b],[Q](l,m,n))*ev([b+],[b])+3*ev([b],[Q](l,m,n))*ev([b+],[b],[b],[Q](i,j,k))-3*ev([b],[b],[Q](i,j,k))*ev([b+],[b])*ev([Q](l,m,n))+3*ev([b],[b],[Q](i,j,k))*ev([b+],[b],[Q](l,m,n))-3*ev([b],[b],[Q](l,m,n))*ev([b+],[b])*ev([Q](i,j,k))+3*ev([b],[b],[Q](l,m,n))*ev([b+],[b],[Q](i,j,k))+ev([b],[b],[b],[Q](i,j,k))*ev([b+],[Q](l,m,n))+ev([b],[b],[b],[Q](l,m,n))*ev([b+],[Q](i,j,k));

id ev([b+],[b],[b],[b],[b],[Q](i?,j?,k?),[Q](l?,m?,n?))=+ev([b+],[b],[b],[b],[b],[Q](i,j,k))*ev([Q](l,m,n))+ev([b+],[b],[b],[b],[b],[Q](l,m,n))*ev([Q](i,j,k))+4*ev([b],[Q](i,j,k))*ev([b+],[b],[b],[b],[Q](l,m,n))+4*ev([b],[Q](l,m,n))*ev([b+],[b],[b],[b],[Q](i,j,k))+6*ev([b],[b],[Q](i,j,k))*ev([b+],[b],[b],[Q](l,m,n))-12*ev([b],[b],[Q](i,j,k))*ev([b],[Q](l,m,n))*ev([b+],[b])+6*ev([b],[b],[Q](l,m,n))*ev([b+],[b],[b],[Q](i,j,k))-12*ev([b],[b],[Q](l,m,n))*ev([b],[Q](i,j,k))*ev([b+],[b])-4*ev([b],[b],[b],[Q](i,j,k))*ev([b+],[b])*ev([Q](l,m,n))+4*ev([b],[b],[b],[Q](i,j,k))*ev([b+],[b],[Q](l,m,n))-4*ev([b],[b],[b],[Q](l,m,n))*ev([b+],[b])*ev([Q](i,j,k))+4*ev([b],[b],[b],[Q](l,m,n))*ev([b+],[b],[Q](i,j,k))+ev([b],[b],[b],[b],[Q](i,j,k))*ev([b+],[Q](l,m,n))+ev([b],[b],[b],[b],[Q](l,m,n))*ev([b+],[Q](i,j,k));
#endprocedure
