#procedure expectationvaluetableQDC1PhC8
***input:					
***output:	sum of products of expectation values containing maximum number of operators as declared by QDC and PhC
***		ev([b+],[b+],[b],[Q](i,j,k),[Q](l,m,n))->sum ev([b+],[b],[Q](i,j,k))*ev([b+],[Q](l,m,n))
***local state:	non factorized expectation values of operators divided by commas


id ev([Q](i?,j?,k?))=+ev([Q](i,j,k));

id ev([b+],[Q](i?,j?,k?))=+ev([b+],[Q](i,j,k));

id ev([b],[Q](i?,j?,k?))=+ev([b],[Q](i,j,k));

id ev([b+],[b],[Q](i?,j?,k?))=+ev([b+],[b],[Q](i,j,k));

id ev([b+],[b+],[b],[Q](i?,j?,k?))=+ev([b+],[b+],[b],[Q](i,j,k));

id ev([b+],[b],[b],[Q](i?,j?,k?))=+ev([b+],[b],[b],[Q](i,j,k));

id ev([b+],[b+],[b],[b],[Q](i?,j?,k?))=+ev([b+],[b+],[b],[b],[Q](i,j,k));

id ev([b+],[b+],[b+],[b],[b],[Q](i?,j?,k?))=+ev([b+],[b+],[b+],[b],[b],[Q](i,j,k));

id ev([b+],[b+],[b],[b],[b],[Q](i?,j?,k?))=+ev([b+],[b+],[b],[b],[b],[Q](i,j,k));

id ev([b+],[b+],[b+],[b],[b],[b],[Q](i?,j?,k?))=+ev([b+],[b+],[b+],[b],[b],[b],[Q](i,j,k));

id ev([b+],[b+],[b+],[b+],[b],[b],[b],[Q](i?,j?,k?))=+ev([b+],[b+],[b+],[b+],[b],[b],[b],[Q](i,j,k));

id ev([b+],[b+],[b+],[b],[b],[b],[b],[Q](i?,j?,k?))=+ev([b+],[b+],[b+],[b],[b],[b],[b],[Q](i,j,k));

id ev([b+],[b+],[b+],[b+],[b],[b],[b],[b],[Q](i?,j?,k?))=+ev([b+],[b+],[b+],[b+],[b],[b],[b],[b])*ev([Q](i,j,k))-36*ev([b+],[b+],[b],[b])^2*ev([Q](i,j,k))+36*ev([b+],[b+],[b],[b])*ev([b+],[b+],[b],[b],[Q](i,j,k))-32*ev([b+],[b])*ev([b+],[b+],[b+],[b],[b],[b])*ev([Q](i,j,k))+16*ev([b+],[b])*ev([b+],[b+],[b+],[b],[b],[b],[Q](i,j,k))+432*ev([b+],[b])^2*ev([b+],[b+],[b],[b])*ev([Q](i,j,k))-144*ev([b+],[b])^2*ev([b+],[b+],[b],[b],[Q](i,j,k))-576*ev([b+],[b])^4*ev([Q](i,j,k))+576*ev([b+],[b])^3*ev([b+],[b],[Q](i,j,k))-288*ev([b+],[b])*ev([b+],[b],[Q](i,j,k))*ev([b+],[b+],[b],[b])+16*ev([b+],[b],[Q](i,j,k))*ev([b+],[b+],[b+],[b],[b],[b]);

id ev([b+],[b+],[b+],[b+],[b+],[b],[b],[b],[b],[Q](i?,j?,k?))=+5*ev([b+],[b+],[b+],[b+],[b],[b],[b],[b])*ev([b+],[Q](i,j,k))+40*ev([b+],[b+],[b],[Q](i,j,k))*ev([b+],[b+],[b+],[b],[b],[b])+60*ev([b+],[b+],[b],[b])*ev([b+],[b+],[b+],[b],[b],[Q](i,j,k))-180*ev([b+],[b+],[b],[b])^2*ev([b+],[Q](i,j,k))+20*ev([b+],[b])*ev([b+],[b+],[b+],[b+],[b],[b],[b],[Q](i,j,k))-160*ev([b+],[b])*ev([b+],[b+],[b+],[b],[b],[b])*ev([b+],[Q](i,j,k))-720*ev([b+],[b])*ev([b+],[b+],[b],[b])*ev([b+],[b+],[b],[Q](i,j,k))-240*ev([b+],[b])^2*ev([b+],[b+],[b+],[b],[b],[Q](i,j,k))+2160*ev([b+],[b])^2*ev([b+],[b+],[b],[b])*ev([b+],[Q](i,j,k))+1440*ev([b+],[b])^3*ev([b+],[b+],[b],[Q](i,j,k))-2880*ev([b+],[b])^4*ev([b+],[Q](i,j,k));

id ev([b+],[b+],[b+],[b+],[b],[b],[b],[b],[b],[Q](i?,j?,k?))=+60*ev([b+],[b+],[b],[b])*ev([b+],[b+],[b],[b],[b],[Q](i,j,k))+20*ev([b+],[b])*ev([b+],[b+],[b+],[b],[b],[b],[b],[Q](i,j,k))-240*ev([b+],[b])^2*ev([b+],[b+],[b],[b],[b],[Q](i,j,k))+1440*ev([b+],[b])^3*ev([b+],[b],[b],[Q](i,j,k))-720*ev([b+],[b])*ev([b+],[b],[b],[Q](i,j,k))*ev([b+],[b+],[b],[b])+40*ev([b+],[b],[b],[Q](i,j,k))*ev([b+],[b+],[b+],[b],[b],[b])+5*ev([b],[Q](i,j,k))*ev([b+],[b+],[b+],[b+],[b],[b],[b],[b])-180*ev([b],[Q](i,j,k))*ev([b+],[b+],[b],[b])^2-160*ev([b],[Q](i,j,k))*ev([b+],[b])*ev([b+],[b+],[b+],[b],[b],[b])+2160*ev([b],[Q](i,j,k))*ev([b+],[b])^2*ev([b+],[b+],[b],[b])-2880*ev([b],[Q](i,j,k))*ev([b+],[b])^4;

id ev([Q](i?,j?,k?),[Q](l?,m?,n?))=+ev([Q](i,j,k))*ev([Q](l,m,n));

id ev([b+],[Q](i?,j?,k?),[Q](l?,m?,n?))=+ev([b+],[Q](i,j,k))*ev([Q](l,m,n))+ev([b+],[Q](l,m,n))*ev([Q](i,j,k));

id ev([b],[Q](i?,j?,k?),[Q](l?,m?,n?))=+ev([b],[Q](i,j,k))*ev([Q](l,m,n))+ev([b],[Q](l,m,n))*ev([Q](i,j,k));

id ev([b+],[b+],[Q](i?,j?,k?))=+ev([b+],[b+],[Q](i,j,k));

id ev([b],[b],[Q](i?,j?,k?))=+ev([b],[b],[Q](i,j,k));

id ev([b+],[b],[Q](i?,j?,k?),[Q](l?,m?,n?))=-ev([b+],[b])*ev([Q](i,j,k))*ev([Q](l,m,n))+ev([b+],[b],[Q](i,j,k))*ev([Q](l,m,n))+ev([b+],[b],[Q](l,m,n))*ev([Q](i,j,k))+ev([b],[Q](i,j,k))*ev([b+],[Q](l,m,n))+ev([b],[Q](l,m,n))*ev([b+],[Q](i,j,k));

id ev([b+],[b+],[b],[Q](i?,j?,k?),[Q](l?,m?,n?))=+ev([b+],[b+],[b],[Q](i,j,k))*ev([Q](l,m,n))+ev([b+],[b+],[b],[Q](l,m,n))*ev([Q](i,j,k))-2*ev([b+],[b])*ev([b+],[Q](i,j,k))*ev([Q](l,m,n))-2*ev([b+],[b])*ev([b+],[Q](l,m,n))*ev([Q](i,j,k))+2*ev([b+],[b],[Q](i,j,k))*ev([b+],[Q](l,m,n))+2*ev([b+],[b],[Q](l,m,n))*ev([b+],[Q](i,j,k))+ev([b],[Q](i,j,k))*ev([b+],[b+],[Q](l,m,n))+ev([b],[Q](l,m,n))*ev([b+],[b+],[Q](i,j,k));

id ev([b+],[b],[b],[Q](i?,j?,k?),[Q](l?,m?,n?))=+ev([b+],[b],[b],[Q](i,j,k))*ev([Q](l,m,n))+ev([b+],[b],[b],[Q](l,m,n))*ev([Q](i,j,k))-2*ev([b],[Q](i,j,k))*ev([b+],[b])*ev([Q](l,m,n))+2*ev([b],[Q](i,j,k))*ev([b+],[b],[Q](l,m,n))-2*ev([b],[Q](l,m,n))*ev([b+],[b])*ev([Q](i,j,k))+2*ev([b],[Q](l,m,n))*ev([b+],[b],[Q](i,j,k))+ev([b],[b],[Q](i,j,k))*ev([b+],[Q](l,m,n))+ev([b],[b],[Q](l,m,n))*ev([b+],[Q](i,j,k));

id ev([b+],[b+],[b+],[b],[Q](i?,j?,k?))=+ev([b+],[b+],[b+],[b],[Q](i,j,k));

id ev([b+],[b],[b],[b],[Q](i?,j?,k?))=+ev([b+],[b],[b],[b],[Q](i,j,k));

id ev([b+],[b+],[b],[b],[Q](i?,j?,k?),[Q](l?,m?,n?))=-ev([b+],[b+],[b],[b])*ev([Q](i,j,k))*ev([Q](l,m,n))+ev([b+],[b+],[b],[b],[Q](i,j,k))*ev([Q](l,m,n))+ev([b+],[b+],[b],[b],[Q](l,m,n))*ev([Q](i,j,k))+4*ev([b+],[b])^2*ev([Q](i,j,k))*ev([Q](l,m,n))-4*ev([b+],[b])*ev([b+],[b],[Q](i,j,k))*ev([Q](l,m,n))-4*ev([b+],[b])*ev([b+],[b],[Q](l,m,n))*ev([Q](i,j,k))+4*ev([b+],[b],[Q](i,j,k))*ev([b+],[b],[Q](l,m,n))+2*ev([b+],[b],[b],[Q](i,j,k))*ev([b+],[Q](l,m,n))+2*ev([b+],[b],[b],[Q](l,m,n))*ev([b+],[Q](i,j,k))+2*ev([b],[Q](i,j,k))*ev([b+],[b+],[b],[Q](l,m,n))-4*ev([b],[Q](i,j,k))*ev([b+],[b])*ev([b+],[Q](l,m,n))+2*ev([b],[Q](l,m,n))*ev([b+],[b+],[b],[Q](i,j,k))-4*ev([b],[Q](l,m,n))*ev([b+],[b])*ev([b+],[Q](i,j,k))+ev([b],[b],[Q](i,j,k))*ev([b+],[b+],[Q](l,m,n))+ev([b],[b],[Q](l,m,n))*ev([b+],[b+],[Q](i,j,k));

id ev([b+],[b+],[b+],[b],[b],[Q](i?,j?,k?),[Q](l?,m?,n?))=+ev([b+],[b+],[b+],[b],[b],[Q](i,j,k))*ev([Q](l,m,n))+ev([b+],[b+],[b+],[b],[b],[Q](l,m,n))*ev([Q](i,j,k))-3*ev([b+],[b+],[b],[b])*ev([b+],[Q](i,j,k))*ev([Q](l,m,n))-3*ev([b+],[b+],[b],[b])*ev([b+],[Q](l,m,n))*ev([Q](i,j,k))+3*ev([b+],[b+],[b],[b],[Q](i,j,k))*ev([b+],[Q](l,m,n))+3*ev([b+],[b+],[b],[b],[Q](l,m,n))*ev([b+],[Q](i,j,k))-6*ev([b+],[b])*ev([b+],[b+],[b],[Q](i,j,k))*ev([Q](l,m,n))-6*ev([b+],[b])*ev([b+],[b+],[b],[Q](l,m,n))*ev([Q](i,j,k))+12*ev([b+],[b])^2*ev([b+],[Q](i,j,k))*ev([Q](l,m,n))+12*ev([b+],[b])^2*ev([b+],[Q](l,m,n))*ev([Q](i,j,k))-12*ev([b+],[b])*ev([b+],[b],[Q](i,j,k))*ev([b+],[Q](l,m,n))-12*ev([b+],[b])*ev([b+],[b],[Q](l,m,n))*ev([b+],[Q](i,j,k))+6*ev([b+],[b],[Q](i,j,k))*ev([b+],[b+],[b],[Q](l,m,n))+6*ev([b+],[b],[Q](l,m,n))*ev([b+],[b+],[b],[Q](i,j,k))+3*ev([b+],[b],[b],[Q](i,j,k))*ev([b+],[b+],[Q](l,m,n))+3*ev([b+],[b],[b],[Q](l,m,n))*ev([b+],[b+],[Q](i,j,k))+2*ev([b],[Q](i,j,k))*ev([b+],[b+],[b+],[b],[Q](l,m,n))-6*ev([b],[Q](i,j,k))*ev([b+],[b])*ev([b+],[b+],[Q](l,m,n))+2*ev([b],[Q](l,m,n))*ev([b+],[b+],[b+],[b],[Q](i,j,k))-6*ev([b],[Q](l,m,n))*ev([b+],[b])*ev([b+],[b+],[Q](i,j,k))+ev([b],[b],[Q](i,j,k))*ev([b+],[b+],[b+],[Q](l,m,n))+ev([b],[b],[Q](l,m,n))*ev([b+],[b+],[b+],[Q](i,j,k));

id ev([b+],[b+],[b],[b],[b],[Q](i?,j?,k?),[Q](l?,m?,n?))=+ev([b+],[b+],[b],[b],[b],[Q](i,j,k))*ev([Q](l,m,n))+ev([b+],[b+],[b],[b],[b],[Q](l,m,n))*ev([Q](i,j,k))-6*ev([b+],[b])*ev([b+],[b],[b],[Q](i,j,k))*ev([Q](l,m,n))-6*ev([b+],[b])*ev([b+],[b],[b],[Q](l,m,n))*ev([Q](i,j,k))+6*ev([b+],[b],[b],[Q](i,j,k))*ev([b+],[b],[Q](l,m,n))+6*ev([b+],[b],[b],[Q](l,m,n))*ev([b+],[b],[Q](i,j,k))+2*ev([b+],[b],[b],[b],[Q](i,j,k))*ev([b+],[Q](l,m,n))+2*ev([b+],[b],[b],[b],[Q](l,m,n))*ev([b+],[Q](i,j,k))-3*ev([b],[Q](i,j,k))*ev([b+],[b+],[b],[b])*ev([Q](l,m,n))+3*ev([b],[Q](i,j,k))*ev([b+],[b+],[b],[b],[Q](l,m,n))+12*ev([b],[Q](i,j,k))*ev([b+],[b])^2*ev([Q](l,m,n))-12*ev([b],[Q](i,j,k))*ev([b+],[b])*ev([b+],[b],[Q](l,m,n))-3*ev([b],[Q](l,m,n))*ev([b+],[b+],[b],[b])*ev([Q](i,j,k))+3*ev([b],[Q](l,m,n))*ev([b+],[b+],[b],[b],[Q](i,j,k))+12*ev([b],[Q](l,m,n))*ev([b+],[b])^2*ev([Q](i,j,k))-12*ev([b],[Q](l,m,n))*ev([b+],[b])*ev([b+],[b],[Q](i,j,k))+3*ev([b],[b],[Q](i,j,k))*ev([b+],[b+],[b],[Q](l,m,n))-6*ev([b],[b],[Q](i,j,k))*ev([b+],[b])*ev([b+],[Q](l,m,n))+3*ev([b],[b],[Q](l,m,n))*ev([b+],[b+],[b],[Q](i,j,k))-6*ev([b],[b],[Q](l,m,n))*ev([b+],[b])*ev([b+],[Q](i,j,k))+ev([b],[b],[b],[Q](i,j,k))*ev([b+],[b+],[Q](l,m,n))+ev([b],[b],[b],[Q](l,m,n))*ev([b+],[b+],[Q](i,j,k));

id ev([b+],[b+],[b+],[b+],[b],[b],[Q](i?,j?,k?))=+ev([b+],[b+],[b+],[b+],[b],[b],[Q](i,j,k));

id ev([b+],[b+],[b],[b],[b],[b],[Q](i?,j?,k?))=+ev([b+],[b+],[b],[b],[b],[b],[Q](i,j,k));

id ev([b+],[b+],[b+],[b],[b],[b],[Q](i?,j?,k?),[Q](l?,m?,n?))=-ev([b+],[b+],[b+],[b],[b],[b])*ev([Q](i,j,k))*ev([Q](l,m,n))+ev([b+],[b+],[b+],[b],[b],[b],[Q](i,j,k))*ev([Q](l,m,n))+ev([b+],[b+],[b+],[b],[b],[b],[Q](l,m,n))*ev([Q](i,j,k))+3*ev([b+],[b+],[b],[b],[b],[Q](i,j,k))*ev([b+],[Q](l,m,n))+3*ev([b+],[b+],[b],[b],[b],[Q](l,m,n))*ev([b+],[Q](i,j,k))+18*ev([b+],[b])*ev([b+],[b+],[b],[b])*ev([Q](i,j,k))*ev([Q](l,m,n))-9*ev([b+],[b])*ev([b+],[b+],[b],[b],[Q](i,j,k))*ev([Q](l,m,n))-9*ev([b+],[b])*ev([b+],[b+],[b],[b],[Q](l,m,n))*ev([Q](i,j,k))-36*ev([b+],[b])^3*ev([Q](i,j,k))*ev([Q](l,m,n))+36*ev([b+],[b])^2*ev([b+],[b],[Q](i,j,k))*ev([Q](l,m,n))+36*ev([b+],[b])^2*ev([b+],[b],[Q](l,m,n))*ev([Q](i,j,k))-36*ev([b+],[b])*ev([b+],[b],[Q](i,j,k))*ev([b+],[b],[Q](l,m,n))-18*ev([b+],[b])*ev([b+],[b],[b],[Q](i,j,k))*ev([b+],[Q](l,m,n))-18*ev([b+],[b])*ev([b+],[b],[b],[Q](l,m,n))*ev([b+],[Q](i,j,k))-9*ev([b+],[b],[Q](i,j,k))*ev([b+],[b+],[b],[b])*ev([Q](l,m,n))+9*ev([b+],[b],[Q](i,j,k))*ev([b+],[b+],[b],[b],[Q](l,m,n))-9*ev([b+],[b],[Q](l,m,n))*ev([b+],[b+],[b],[b])*ev([Q](i,j,k))+9*ev([b+],[b],[Q](l,m,n))*ev([b+],[b+],[b],[b],[Q](i,j,k))+9*ev([b+],[b],[b],[Q](i,j,k))*ev([b+],[b+],[b],[Q](l,m,n))+9*ev([b+],[b],[b],[Q](l,m,n))*ev([b+],[b+],[b],[Q](i,j,k))+3*ev([b+],[b],[b],[b],[Q](i,j,k))*ev([b+],[b+],[Q](l,m,n))+3*ev([b+],[b],[b],[b],[Q](l,m,n))*ev([b+],[b+],[Q](i,j,k))+3*ev([b],[Q](i,j,k))*ev([b+],[b+],[b+],[b],[b],[Q](l,m,n))-9*ev([b],[Q](i,j,k))*ev([b+],[b+],[b],[b])*ev([b+],[Q](l,m,n))-18*ev([b],[Q](i,j,k))*ev([b+],[b])*ev([b+],[b+],[b],[Q](l,m,n))+36*ev([b],[Q](i,j,k))*ev([b+],[b])^2*ev([b+],[Q](l,m,n))+3*ev([b],[Q](l,m,n))*ev([b+],[b+],[b+],[b],[b],[Q](i,j,k))-9*ev([b],[Q](l,m,n))*ev([b+],[b+],[b],[b])*ev([b+],[Q](i,j,k))-18*ev([b],[Q](l,m,n))*ev([b+],[b])*ev([b+],[b+],[b],[Q](i,j,k))+36*ev([b],[Q](l,m,n))*ev([b+],[b])^2*ev([b+],[Q](i,j,k))+3*ev([b],[b],[Q](i,j,k))*ev([b+],[b+],[b+],[b],[Q](l,m,n))-9*ev([b],[b],[Q](i,j,k))*ev([b+],[b])*ev([b+],[b+],[Q](l,m,n))+3*ev([b],[b],[Q](l,m,n))*ev([b+],[b+],[b+],[b],[Q](i,j,k))-9*ev([b],[b],[Q](l,m,n))*ev([b+],[b])*ev([b+],[b+],[Q](i,j,k))+ev([b],[b],[b],[Q](i,j,k))*ev([b+],[b+],[b+],[Q](l,m,n))+ev([b],[b],[b],[Q](l,m,n))*ev([b+],[b+],[b+],[Q](i,j,k));

id ev([b+],[b+],[b+],[b+],[b],[b],[b],[Q](i?,j?,k?),[Q](l?,m?,n?))=+ev([b+],[b+],[b+],[b+],[b],[b],[b],[Q](i,j,k))*ev([Q](l,m,n))+ev([b+],[b+],[b+],[b+],[b],[b],[b],[Q](l,m,n))*ev([Q](i,j,k))-4*ev([b+],[b+],[b+],[b],[b],[b])*ev([b+],[Q](i,j,k))*ev([Q](l,m,n))-4*ev([b+],[b+],[b+],[b],[b],[b])*ev([b+],[Q](l,m,n))*ev([Q](i,j,k))+4*ev([b+],[b+],[b+],[b],[b],[b],[Q](i,j,k))*ev([b+],[Q](l,m,n))+4*ev([b+],[b+],[b+],[b],[b],[b],[Q](l,m,n))*ev([b+],[Q](i,j,k))-18*ev([b+],[b+],[b],[b])*ev([b+],[b+],[b],[Q](i,j,k))*ev([Q](l,m,n))-18*ev([b+],[b+],[b],[b])*ev([b+],[b+],[b],[Q](l,m,n))*ev([Q](i,j,k))+18*ev([b+],[b+],[b],[b],[Q](i,j,k))*ev([b+],[b+],[b],[Q](l,m,n))+18*ev([b+],[b+],[b],[b],[Q](l,m,n))*ev([b+],[b+],[b],[Q](i,j,k))+6*ev([b+],[b+],[b],[b],[b],[Q](i,j,k))*ev([b+],[b+],[Q](l,m,n))+6*ev([b+],[b+],[b],[b],[b],[Q](l,m,n))*ev([b+],[b+],[Q](i,j,k))-12*ev([b+],[b])*ev([b+],[b+],[b+],[b],[b],[Q](i,j,k))*ev([Q](l,m,n))-12*ev([b+],[b])*ev([b+],[b+],[b+],[b],[b],[Q](l,m,n))*ev([Q](i,j,k))+72*ev([b+],[b])*ev([b+],[b+],[b],[b])*ev([b+],[Q](i,j,k))*ev([Q](l,m,n))+72*ev([b+],[b])*ev([b+],[b+],[b],[b])*ev([b+],[Q](l,m,n))*ev([Q](i,j,k))-36*ev([b+],[b])*ev([b+],[b+],[b],[b],[Q](i,j,k))*ev([b+],[Q](l,m,n))-36*ev([b+],[b])*ev([b+],[b+],[b],[b],[Q](l,m,n))*ev([b+],[Q](i,j,k))+72*ev([b+],[b])^2*ev([b+],[b+],[b],[Q](i,j,k))*ev([Q](l,m,n))+72*ev([b+],[b])^2*ev([b+],[b+],[b],[Q](l,m,n))*ev([Q](i,j,k))-144*ev([b+],[b])^3*ev([b+],[Q](i,j,k))*ev([Q](l,m,n))-144*ev([b+],[b])^3*ev([b+],[Q](l,m,n))*ev([Q](i,j,k))+144*ev([b+],[b])^2*ev([b+],[b],[Q](i,j,k))*ev([b+],[Q](l,m,n))+144*ev([b+],[b])^2*ev([b+],[b],[Q](l,m,n))*ev([b+],[Q](i,j,k))-72*ev([b+],[b])*ev([b+],[b],[Q](i,j,k))*ev([b+],[b+],[b],[Q](l,m,n))-72*ev([b+],[b])*ev([b+],[b],[Q](l,m,n))*ev([b+],[b+],[b],[Q](i,j,k))-36*ev([b+],[b])*ev([b+],[b],[b],[Q](i,j,k))*ev([b+],[b+],[Q](l,m,n))-36*ev([b+],[b])*ev([b+],[b],[b],[Q](l,m,n))*ev([b+],[b+],[Q](i,j,k))+12*ev([b+],[b],[Q](i,j,k))*ev([b+],[b+],[b+],[b],[b],[Q](l,m,n))-36*ev([b+],[b],[Q](i,j,k))*ev([b+],[b+],[b],[b])*ev([b+],[Q](l,m,n))+12*ev([b+],[b],[Q](l,m,n))*ev([b+],[b+],[b+],[b],[b],[Q](i,j,k))-36*ev([b+],[b],[Q](l,m,n))*ev([b+],[b+],[b],[b])*ev([b+],[Q](i,j,k))+12*ev([b+],[b],[b],[Q](i,j,k))*ev([b+],[b+],[b+],[b],[Q](l,m,n))+12*ev([b+],[b],[b],[Q](l,m,n))*ev([b+],[b+],[b+],[b],[Q](i,j,k))+4*ev([b+],[b],[b],[b],[Q](i,j,k))*ev([b+],[b+],[b+],[Q](l,m,n))+4*ev([b+],[b],[b],[b],[Q](l,m,n))*ev([b+],[b+],[b+],[Q](i,j,k))+3*ev([b],[Q](i,j,k))*ev([b+],[b+],[b+],[b+],[b],[b],[Q](l,m,n))-18*ev([b],[Q](i,j,k))*ev([b+],[b+],[b],[b])*ev([b+],[b+],[Q](l,m,n))-24*ev([b],[Q](i,j,k))*ev([b+],[b])*ev([b+],[b+],[b+],[b],[Q](l,m,n))+72*ev([b],[Q](i,j,k))*ev([b+],[b])^2*ev([b+],[b+],[Q](l,m,n))+3*ev([b],[Q](l,m,n))*ev([b+],[b+],[b+],[b+],[b],[b],[Q](i,j,k))-18*ev([b],[Q](l,m,n))*ev([b+],[b+],[b],[b])*ev([b+],[b+],[Q](i,j,k))-24*ev([b],[Q](l,m,n))*ev([b+],[b])*ev([b+],[b+],[b+],[b],[Q](i,j,k))+72*ev([b],[Q](l,m,n))*ev([b+],[b])^2*ev([b+],[b+],[Q](i,j,k))+3*ev([b],[b],[Q](i,j,k))*ev([b+],[b+],[b+],[b+],[b],[Q](l,m,n))-12*ev([b],[b],[Q](i,j,k))*ev([b+],[b])*ev([b+],[b+],[b+],[Q](l,m,n))+3*ev([b],[b],[Q](l,m,n))*ev([b+],[b+],[b+],[b+],[b],[Q](i,j,k))-12*ev([b],[b],[Q](l,m,n))*ev([b+],[b])*ev([b+],[b+],[b+],[Q](i,j,k))+ev([b],[b],[b],[Q](i,j,k))*ev([b+],[b+],[b+],[b+],[Q](l,m,n))+ev([b],[b],[b],[Q](l,m,n))*ev([b+],[b+],[b+],[b+],[Q](i,j,k));

id ev([b+],[b+],[b+],[b],[b],[b],[b],[Q](i?,j?,k?),[Q](l?,m?,n?))=+ev([b+],[b+],[b+],[b],[b],[b],[b],[Q](i,j,k))*ev([Q](l,m,n))+ev([b+],[b+],[b+],[b],[b],[b],[b],[Q](l,m,n))*ev([Q](i,j,k))+3*ev([b+],[b+],[b],[b],[b],[b],[Q](i,j,k))*ev([b+],[Q](l,m,n))+3*ev([b+],[b+],[b],[b],[b],[b],[Q](l,m,n))*ev([b+],[Q](i,j,k))-12*ev([b+],[b])*ev([b+],[b+],[b],[b],[b],[Q](i,j,k))*ev([Q](l,m,n))-12*ev([b+],[b])*ev([b+],[b+],[b],[b],[b],[Q](l,m,n))*ev([Q](i,j,k))+72*ev([b+],[b])^2*ev([b+],[b],[b],[Q](i,j,k))*ev([Q](l,m,n))+72*ev([b+],[b])^2*ev([b+],[b],[b],[Q](l,m,n))*ev([Q](i,j,k))-72*ev([b+],[b])*ev([b+],[b],[b],[Q](i,j,k))*ev([b+],[b],[Q](l,m,n))-72*ev([b+],[b])*ev([b+],[b],[b],[Q](l,m,n))*ev([b+],[b],[Q](i,j,k))-24*ev([b+],[b])*ev([b+],[b],[b],[b],[Q](i,j,k))*ev([b+],[Q](l,m,n))-24*ev([b+],[b])*ev([b+],[b],[b],[b],[Q](l,m,n))*ev([b+],[Q](i,j,k))+12*ev([b+],[b],[Q](i,j,k))*ev([b+],[b+],[b],[b],[b],[Q](l,m,n))+12*ev([b+],[b],[Q](l,m,n))*ev([b+],[b+],[b],[b],[b],[Q](i,j,k))-18*ev([b+],[b],[b],[Q](i,j,k))*ev([b+],[b+],[b],[b])*ev([Q](l,m,n))+18*ev([b+],[b],[b],[Q](i,j,k))*ev([b+],[b+],[b],[b],[Q](l,m,n))-18*ev([b+],[b],[b],[Q](l,m,n))*ev([b+],[b+],[b],[b])*ev([Q](i,j,k))+18*ev([b+],[b],[b],[Q](l,m,n))*ev([b+],[b+],[b],[b],[Q](i,j,k))+12*ev([b+],[b],[b],[b],[Q](i,j,k))*ev([b+],[b+],[b],[Q](l,m,n))+12*ev([b+],[b],[b],[b],[Q](l,m,n))*ev([b+],[b+],[b],[Q](i,j,k))+3*ev([b+],[b],[b],[b],[b],[Q](i,j,k))*ev([b+],[b+],[Q](l,m,n))+3*ev([b+],[b],[b],[b],[b],[Q](l,m,n))*ev([b+],[b+],[Q](i,j,k))-4*ev([b],[Q](i,j,k))*ev([b+],[b+],[b+],[b],[b],[b])*ev([Q](l,m,n))+4*ev([b],[Q](i,j,k))*ev([b+],[b+],[b+],[b],[b],[b],[Q](l,m,n))+72*ev([b],[Q](i,j,k))*ev([b+],[b])*ev([b+],[b+],[b],[b])*ev([Q](l,m,n))-36*ev([b],[Q](i,j,k))*ev([b+],[b])*ev([b+],[b+],[b],[b],[Q](l,m,n))-144*ev([b],[Q](i,j,k))*ev([b+],[b])^3*ev([Q](l,m,n))+144*ev([b],[Q](i,j,k))*ev([b+],[b])^2*ev([b+],[b],[Q](l,m,n))-36*ev([b],[Q](i,j,k))*ev([b+],[b],[Q](l,m,n))*ev([b+],[b+],[b],[b])-4*ev([b],[Q](l,m,n))*ev([b+],[b+],[b+],[b],[b],[b])*ev([Q](i,j,k))+4*ev([b],[Q](l,m,n))*ev([b+],[b+],[b+],[b],[b],[b],[Q](i,j,k))+72*ev([b],[Q](l,m,n))*ev([b+],[b])*ev([b+],[b+],[b],[b])*ev([Q](i,j,k))-36*ev([b],[Q](l,m,n))*ev([b+],[b])*ev([b+],[b+],[b],[b],[Q](i,j,k))-144*ev([b],[Q](l,m,n))*ev([b+],[b])^3*ev([Q](i,j,k))+144*ev([b],[Q](l,m,n))*ev([b+],[b])^2*ev([b+],[b],[Q](i,j,k))-36*ev([b],[Q](l,m,n))*ev([b+],[b],[Q](i,j,k))*ev([b+],[b+],[b],[b])+6*ev([b],[b],[Q](i,j,k))*ev([b+],[b+],[b+],[b],[b],[Q](l,m,n))-18*ev([b],[b],[Q](i,j,k))*ev([b+],[b+],[b],[b])*ev([b+],[Q](l,m,n))-36*ev([b],[b],[Q](i,j,k))*ev([b+],[b])*ev([b+],[b+],[b],[Q](l,m,n))+72*ev([b],[b],[Q](i,j,k))*ev([b+],[b])^2*ev([b+],[Q](l,m,n))+6*ev([b],[b],[Q](l,m,n))*ev([b+],[b+],[b+],[b],[b],[Q](i,j,k))-18*ev([b],[b],[Q](l,m,n))*ev([b+],[b+],[b],[b])*ev([b+],[Q](i,j,k))-36*ev([b],[b],[Q](l,m,n))*ev([b+],[b])*ev([b+],[b+],[b],[Q](i,j,k))+72*ev([b],[b],[Q](l,m,n))*ev([b+],[b])^2*ev([b+],[Q](i,j,k))+4*ev([b],[b],[b],[Q](i,j,k))*ev([b+],[b+],[b+],[b],[Q](l,m,n))-12*ev([b],[b],[b],[Q](i,j,k))*ev([b+],[b])*ev([b+],[b+],[Q](l,m,n))+4*ev([b],[b],[b],[Q](l,m,n))*ev([b+],[b+],[b+],[b],[Q](i,j,k))-12*ev([b],[b],[b],[Q](l,m,n))*ev([b+],[b])*ev([b+],[b+],[Q](i,j,k))+ev([b],[b],[b],[b],[Q](i,j,k))*ev([b+],[b+],[b+],[Q](l,m,n))+ev([b],[b],[b],[b],[Q](l,m,n))*ev([b+],[b+],[b+],[Q](i,j,k));

id ev([b+],[b+],[b+],[b+],[b+],[b],[b],[b],[Q](i?,j?,k?))=+10*ev([b+],[b+],[b+],[b],[b],[b])*ev([b+],[b+],[Q](i,j,k))+30*ev([b+],[b+],[b],[b])*ev([b+],[b+],[b+],[b],[Q](i,j,k))+15*ev([b+],[b])*ev([b+],[b+],[b+],[b+],[b],[b],[Q](i,j,k))-180*ev([b+],[b])*ev([b+],[b+],[b],[b])*ev([b+],[b+],[Q](i,j,k))-120*ev([b+],[b])^2*ev([b+],[b+],[b+],[b],[Q](i,j,k))+360*ev([b+],[b])^3*ev([b+],[b+],[Q](i,j,k));

id ev([b+],[b+],[b+],[b],[b],[b],[b],[b],[Q](i?,j?,k?))=+15*ev([b+],[b])*ev([b+],[b+],[b],[b],[b],[b],[Q](i,j,k))-120*ev([b+],[b])^2*ev([b+],[b],[b],[b],[Q](i,j,k))+30*ev([b+],[b],[b],[b],[Q](i,j,k))*ev([b+],[b+],[b],[b])+10*ev([b],[b],[Q](i,j,k))*ev([b+],[b+],[b+],[b],[b],[b])-180*ev([b],[b],[Q](i,j,k))*ev([b+],[b])*ev([b+],[b+],[b],[b])+360*ev([b],[b],[Q](i,j,k))*ev([b+],[b])^3;

id ev([b+],[b+],[Q](i?,j?,k?),[Q](l?,m?,n?))=+2*ev([b+],[Q](i,j,k))*ev([b+],[Q](l,m,n))+ev([b+],[b+],[Q](i,j,k))*ev([Q](l,m,n))+ev([b+],[b+],[Q](l,m,n))*ev([Q](i,j,k));

id ev([b+],[b+],[b+],[Q](i?,j?,k?),[Q](l?,m?,n?))=+3*ev([b+],[b+],[Q](i,j,k))*ev([b+],[Q](l,m,n))+3*ev([b+],[b+],[Q](l,m,n))*ev([b+],[Q](i,j,k))+ev([b+],[b+],[b+],[Q](i,j,k))*ev([Q](l,m,n))+ev([b+],[b+],[b+],[Q](l,m,n))*ev([Q](i,j,k));

id ev([b],[b],[Q](i?,j?,k?),[Q](l?,m?,n?))=+2*ev([b],[Q](i,j,k))*ev([b],[Q](l,m,n))+ev([b],[b],[Q](i,j,k))*ev([Q](l,m,n))+ev([b],[b],[Q](l,m,n))*ev([Q](i,j,k));

id ev([b],[b],[b],[Q](i?,j?,k?),[Q](l?,m?,n?))=+3*ev([b],[b],[Q](i,j,k))*ev([b],[Q](l,m,n))+3*ev([b],[b],[Q](l,m,n))*ev([b],[Q](i,j,k))+ev([b],[b],[b],[Q](i,j,k))*ev([Q](l,m,n))+ev([b],[b],[b],[Q](l,m,n))*ev([Q](i,j,k));

id ev([b+],[b+],[b+],[b],[Q](i?,j?,k?),[Q](l?,m?,n?))=+ev([b+],[b+],[b+],[b],[Q](i,j,k))*ev([Q](l,m,n))+ev([b+],[b+],[b+],[b],[Q](l,m,n))*ev([Q](i,j,k))+3*ev([b+],[b+],[b],[Q](i,j,k))*ev([b+],[Q](l,m,n))+3*ev([b+],[b+],[b],[Q](l,m,n))*ev([b+],[Q](i,j,k))-6*ev([b+],[b])*ev([b+],[Q](i,j,k))*ev([b+],[Q](l,m,n))-3*ev([b+],[b])*ev([b+],[b+],[Q](i,j,k))*ev([Q](l,m,n))-3*ev([b+],[b])*ev([b+],[b+],[Q](l,m,n))*ev([Q](i,j,k))+3*ev([b+],[b],[Q](i,j,k))*ev([b+],[b+],[Q](l,m,n))+3*ev([b+],[b],[Q](l,m,n))*ev([b+],[b+],[Q](i,j,k))+ev([b],[Q](i,j,k))*ev([b+],[b+],[b+],[Q](l,m,n))+ev([b],[Q](l,m,n))*ev([b+],[b+],[b+],[Q](i,j,k));

id ev([b+],[b+],[b+],[b+],[b],[Q](i?,j?,k?),[Q](l?,m?,n?))=+ev([b+],[b+],[b+],[b+],[b],[Q](i,j,k))*ev([Q](l,m,n))+ev([b+],[b+],[b+],[b+],[b],[Q](l,m,n))*ev([Q](i,j,k))+4*ev([b+],[b+],[b+],[b],[Q](i,j,k))*ev([b+],[Q](l,m,n))+4*ev([b+],[b+],[b+],[b],[Q](l,m,n))*ev([b+],[Q](i,j,k))+6*ev([b+],[b+],[b],[Q](i,j,k))*ev([b+],[b+],[Q](l,m,n))+6*ev([b+],[b+],[b],[Q](l,m,n))*ev([b+],[b+],[Q](i,j,k))-12*ev([b+],[b])*ev([b+],[b+],[Q](i,j,k))*ev([b+],[Q](l,m,n))-12*ev([b+],[b])*ev([b+],[b+],[Q](l,m,n))*ev([b+],[Q](i,j,k))-4*ev([b+],[b])*ev([b+],[b+],[b+],[Q](i,j,k))*ev([Q](l,m,n))-4*ev([b+],[b])*ev([b+],[b+],[b+],[Q](l,m,n))*ev([Q](i,j,k))+4*ev([b+],[b],[Q](i,j,k))*ev([b+],[b+],[b+],[Q](l,m,n))+4*ev([b+],[b],[Q](l,m,n))*ev([b+],[b+],[b+],[Q](i,j,k))+ev([b],[Q](i,j,k))*ev([b+],[b+],[b+],[b+],[Q](l,m,n))+ev([b],[Q](l,m,n))*ev([b+],[b+],[b+],[b+],[Q](i,j,k));

id ev([b+],[b],[b],[b],[Q](i?,j?,k?),[Q](l?,m?,n?))=+ev([b+],[b],[b],[b],[Q](i,j,k))*ev([Q](l,m,n))+ev([b+],[b],[b],[b],[Q](l,m,n))*ev([Q](i,j,k))+3*ev([b],[Q](i,j,k))*ev([b+],[b],[b],[Q](l,m,n))-6*ev([b],[Q](i,j,k))*ev([b],[Q](l,m,n))*ev([b+],[b])+3*ev([b],[Q](l,m,n))*ev([b+],[b],[b],[Q](i,j,k))-3*ev([b],[b],[Q](i,j,k))*ev([b+],[b])*ev([Q](l,m,n))+3*ev([b],[b],[Q](i,j,k))*ev([b+],[b],[Q](l,m,n))-3*ev([b],[b],[Q](l,m,n))*ev([b+],[b])*ev([Q](i,j,k))+3*ev([b],[b],[Q](l,m,n))*ev([b+],[b],[Q](i,j,k))+ev([b],[b],[b],[Q](i,j,k))*ev([b+],[Q](l,m,n))+ev([b],[b],[b],[Q](l,m,n))*ev([b+],[Q](i,j,k));

id ev([b+],[b],[b],[b],[b],[Q](i?,j?,k?),[Q](l?,m?,n?))=+ev([b+],[b],[b],[b],[b],[Q](i,j,k))*ev([Q](l,m,n))+ev([b+],[b],[b],[b],[b],[Q](l,m,n))*ev([Q](i,j,k))+4*ev([b],[Q](i,j,k))*ev([b+],[b],[b],[b],[Q](l,m,n))+4*ev([b],[Q](l,m,n))*ev([b+],[b],[b],[b],[Q](i,j,k))+6*ev([b],[b],[Q](i,j,k))*ev([b+],[b],[b],[Q](l,m,n))-12*ev([b],[b],[Q](i,j,k))*ev([b],[Q](l,m,n))*ev([b+],[b])+6*ev([b],[b],[Q](l,m,n))*ev([b+],[b],[b],[Q](i,j,k))-12*ev([b],[b],[Q](l,m,n))*ev([b],[Q](i,j,k))*ev([b+],[b])-4*ev([b],[b],[b],[Q](i,j,k))*ev([b+],[b])*ev([Q](l,m,n))+4*ev([b],[b],[b],[Q](i,j,k))*ev([b+],[b],[Q](l,m,n))-4*ev([b],[b],[b],[Q](l,m,n))*ev([b+],[b])*ev([Q](i,j,k))+4*ev([b],[b],[b],[Q](l,m,n))*ev([b+],[b],[Q](i,j,k))+ev([b],[b],[b],[b],[Q](i,j,k))*ev([b+],[Q](l,m,n))+ev([b],[b],[b],[b],[Q](l,m,n))*ev([b+],[Q](i,j,k));

id ev([b+],[b+],[b+],[b+],[b],[b],[Q](i?,j?,k?),[Q](l?,m?,n?))=+ev([b+],[b+],[b+],[b+],[b],[b],[Q](i,j,k))*ev([Q](l,m,n))+ev([b+],[b+],[b+],[b+],[b],[b],[Q](l,m,n))*ev([Q](i,j,k))+4*ev([b+],[b+],[b+],[b],[b],[Q](i,j,k))*ev([b+],[Q](l,m,n))+4*ev([b+],[b+],[b+],[b],[b],[Q](l,m,n))*ev([b+],[Q](i,j,k))+12*ev([b+],[b+],[b],[Q](i,j,k))*ev([b+],[b+],[b],[Q](l,m,n))-12*ev([b+],[b+],[b],[b])*ev([b+],[Q](i,j,k))*ev([b+],[Q](l,m,n))-6*ev([b+],[b+],[b],[b])*ev([b+],[b+],[Q](i,j,k))*ev([Q](l,m,n))-6*ev([b+],[b+],[b],[b])*ev([b+],[b+],[Q](l,m,n))*ev([Q](i,j,k))+6*ev([b+],[b+],[b],[b],[Q](i,j,k))*ev([b+],[b+],[Q](l,m,n))+6*ev([b+],[b+],[b],[b],[Q](l,m,n))*ev([b+],[b+],[Q](i,j,k))-8*ev([b+],[b])*ev([b+],[b+],[b+],[b],[Q](i,j,k))*ev([Q](l,m,n))-8*ev([b+],[b])*ev([b+],[b+],[b+],[b],[Q](l,m,n))*ev([Q](i,j,k))-24*ev([b+],[b])*ev([b+],[b+],[b],[Q](i,j,k))*ev([b+],[Q](l,m,n))-24*ev([b+],[b])*ev([b+],[b+],[b],[Q](l,m,n))*ev([b+],[Q](i,j,k))+48*ev([b+],[b])^2*ev([b+],[Q](i,j,k))*ev([b+],[Q](l,m,n))+24*ev([b+],[b])^2*ev([b+],[b+],[Q](i,j,k))*ev([Q](l,m,n))+24*ev([b+],[b])^2*ev([b+],[b+],[Q](l,m,n))*ev([Q](i,j,k))-24*ev([b+],[b])*ev([b+],[b],[Q](i,j,k))*ev([b+],[b+],[Q](l,m,n))-24*ev([b+],[b])*ev([b+],[b],[Q](l,m,n))*ev([b+],[b+],[Q](i,j,k))+8*ev([b+],[b],[Q](i,j,k))*ev([b+],[b+],[b+],[b],[Q](l,m,n))+8*ev([b+],[b],[Q](l,m,n))*ev([b+],[b+],[b+],[b],[Q](i,j,k))+4*ev([b+],[b],[b],[Q](i,j,k))*ev([b+],[b+],[b+],[Q](l,m,n))+4*ev([b+],[b],[b],[Q](l,m,n))*ev([b+],[b+],[b+],[Q](i,j,k))+2*ev([b],[Q](i,j,k))*ev([b+],[b+],[b+],[b+],[b],[Q](l,m,n))-8*ev([b],[Q](i,j,k))*ev([b+],[b])*ev([b+],[b+],[b+],[Q](l,m,n))+2*ev([b],[Q](l,m,n))*ev([b+],[b+],[b+],[b+],[b],[Q](i,j,k))-8*ev([b],[Q](l,m,n))*ev([b+],[b])*ev([b+],[b+],[b+],[Q](i,j,k))+ev([b],[b],[Q](i,j,k))*ev([b+],[b+],[b+],[b+],[Q](l,m,n))+ev([b],[b],[Q](l,m,n))*ev([b+],[b+],[b+],[b+],[Q](i,j,k));

id ev([b+],[b+],[b+],[b+],[b+],[b],[b],[Q](i?,j?,k?),[Q](l?,m?,n?))=+ev([b+],[b+],[b+],[b+],[b+],[b],[b],[Q](i,j,k))*ev([Q](l,m,n))+ev([b+],[b+],[b+],[b+],[b+],[b],[b],[Q](l,m,n))*ev([Q](i,j,k))+5*ev([b+],[b+],[b+],[b+],[b],[b],[Q](i,j,k))*ev([b+],[Q](l,m,n))+5*ev([b+],[b+],[b+],[b+],[b],[b],[Q](l,m,n))*ev([b+],[Q](i,j,k))+10*ev([b+],[b+],[b+],[b],[b],[Q](i,j,k))*ev([b+],[b+],[Q](l,m,n))+10*ev([b+],[b+],[b+],[b],[b],[Q](l,m,n))*ev([b+],[b+],[Q](i,j,k))+20*ev([b+],[b+],[b],[Q](i,j,k))*ev([b+],[b+],[b+],[b],[Q](l,m,n))+20*ev([b+],[b+],[b],[Q](l,m,n))*ev([b+],[b+],[b+],[b],[Q](i,j,k))-30*ev([b+],[b+],[b],[b])*ev([b+],[b+],[Q](i,j,k))*ev([b+],[Q](l,m,n))-30*ev([b+],[b+],[b],[b])*ev([b+],[b+],[Q](l,m,n))*ev([b+],[Q](i,j,k))-10*ev([b+],[b+],[b],[b])*ev([b+],[b+],[b+],[Q](i,j,k))*ev([Q](l,m,n))-10*ev([b+],[b+],[b],[b])*ev([b+],[b+],[b+],[Q](l,m,n))*ev([Q](i,j,k))+10*ev([b+],[b+],[b],[b],[Q](i,j,k))*ev([b+],[b+],[b+],[Q](l,m,n))+10*ev([b+],[b+],[b],[b],[Q](l,m,n))*ev([b+],[b+],[b+],[Q](i,j,k))-10*ev([b+],[b])*ev([b+],[b+],[b+],[b+],[b],[Q](i,j,k))*ev([Q](l,m,n))-10*ev([b+],[b])*ev([b+],[b+],[b+],[b+],[b],[Q](l,m,n))*ev([Q](i,j,k))-40*ev([b+],[b])*ev([b+],[b+],[b+],[b],[Q](i,j,k))*ev([b+],[Q](l,m,n))-40*ev([b+],[b])*ev([b+],[b+],[b+],[b],[Q](l,m,n))*ev([b+],[Q](i,j,k))-60*ev([b+],[b])*ev([b+],[b+],[b],[Q](i,j,k))*ev([b+],[b+],[Q](l,m,n))-60*ev([b+],[b])*ev([b+],[b+],[b],[Q](l,m,n))*ev([b+],[b+],[Q](i,j,k))+120*ev([b+],[b])^2*ev([b+],[b+],[Q](i,j,k))*ev([b+],[Q](l,m,n))+120*ev([b+],[b])^2*ev([b+],[b+],[Q](l,m,n))*ev([b+],[Q](i,j,k))+40*ev([b+],[b])^2*ev([b+],[b+],[b+],[Q](i,j,k))*ev([Q](l,m,n))+40*ev([b+],[b])^2*ev([b+],[b+],[b+],[Q](l,m,n))*ev([Q](i,j,k))-40*ev([b+],[b])*ev([b+],[b],[Q](i,j,k))*ev([b+],[b+],[b+],[Q](l,m,n))-40*ev([b+],[b])*ev([b+],[b],[Q](l,m,n))*ev([b+],[b+],[b+],[Q](i,j,k))+10*ev([b+],[b],[Q](i,j,k))*ev([b+],[b+],[b+],[b+],[b],[Q](l,m,n))+10*ev([b+],[b],[Q](l,m,n))*ev([b+],[b+],[b+],[b+],[b],[Q](i,j,k))+5*ev([b+],[b],[b],[Q](i,j,k))*ev([b+],[b+],[b+],[b+],[Q](l,m,n))+5*ev([b+],[b],[b],[Q](l,m,n))*ev([b+],[b+],[b+],[b+],[Q](i,j,k))+2*ev([b],[Q](i,j,k))*ev([b+],[b+],[b+],[b+],[b+],[b],[Q](l,m,n))-10*ev([b],[Q](i,j,k))*ev([b+],[b])*ev([b+],[b+],[b+],[b+],[Q](l,m,n))+2*ev([b],[Q](l,m,n))*ev([b+],[b+],[b+],[b+],[b+],[b],[Q](i,j,k))-10*ev([b],[Q](l,m,n))*ev([b+],[b])*ev([b+],[b+],[b+],[b+],[Q](i,j,k))+ev([b],[b],[Q](i,j,k))*ev([b+],[b+],[b+],[b+],[b+],[Q](l,m,n))+ev([b],[b],[Q](l,m,n))*ev([b+],[b+],[b+],[b+],[b+],[Q](i,j,k));

id ev([b+],[b+],[b],[b],[b],[b],[Q](i?,j?,k?),[Q](l?,m?,n?))=+ev([b+],[b+],[b],[b],[b],[b],[Q](i,j,k))*ev([Q](l,m,n))+ev([b+],[b+],[b],[b],[b],[b],[Q](l,m,n))*ev([Q](i,j,k))-8*ev([b+],[b])*ev([b+],[b],[b],[b],[Q](i,j,k))*ev([Q](l,m,n))-8*ev([b+],[b])*ev([b+],[b],[b],[b],[Q](l,m,n))*ev([Q](i,j,k))+12*ev([b+],[b],[b],[Q](i,j,k))*ev([b+],[b],[b],[Q](l,m,n))+8*ev([b+],[b],[b],[b],[Q](i,j,k))*ev([b+],[b],[Q](l,m,n))+8*ev([b+],[b],[b],[b],[Q](l,m,n))*ev([b+],[b],[Q](i,j,k))+2*ev([b+],[b],[b],[b],[b],[Q](i,j,k))*ev([b+],[Q](l,m,n))+2*ev([b+],[b],[b],[b],[b],[Q](l,m,n))*ev([b+],[Q](i,j,k))+4*ev([b],[Q](i,j,k))*ev([b+],[b+],[b],[b],[b],[Q](l,m,n))-24*ev([b],[Q](i,j,k))*ev([b+],[b])*ev([b+],[b],[b],[Q](l,m,n))-12*ev([b],[Q](i,j,k))*ev([b],[Q](l,m,n))*ev([b+],[b+],[b],[b])+48*ev([b],[Q](i,j,k))*ev([b],[Q](l,m,n))*ev([b+],[b])^2+4*ev([b],[Q](l,m,n))*ev([b+],[b+],[b],[b],[b],[Q](i,j,k))-24*ev([b],[Q](l,m,n))*ev([b+],[b])*ev([b+],[b],[b],[Q](i,j,k))-6*ev([b],[b],[Q](i,j,k))*ev([b+],[b+],[b],[b])*ev([Q](l,m,n))+6*ev([b],[b],[Q](i,j,k))*ev([b+],[b+],[b],[b],[Q](l,m,n))+24*ev([b],[b],[Q](i,j,k))*ev([b+],[b])^2*ev([Q](l,m,n))-24*ev([b],[b],[Q](i,j,k))*ev([b+],[b])*ev([b+],[b],[Q](l,m,n))-6*ev([b],[b],[Q](l,m,n))*ev([b+],[b+],[b],[b])*ev([Q](i,j,k))+6*ev([b],[b],[Q](l,m,n))*ev([b+],[b+],[b],[b],[Q](i,j,k))+24*ev([b],[b],[Q](l,m,n))*ev([b+],[b])^2*ev([Q](i,j,k))-24*ev([b],[b],[Q](l,m,n))*ev([b+],[b])*ev([b+],[b],[Q](i,j,k))+4*ev([b],[b],[b],[Q](i,j,k))*ev([b+],[b+],[b],[Q](l,m,n))-8*ev([b],[b],[b],[Q](i,j,k))*ev([b+],[b])*ev([b+],[Q](l,m,n))+4*ev([b],[b],[b],[Q](l,m,n))*ev([b+],[b+],[b],[Q](i,j,k))-8*ev([b],[b],[b],[Q](l,m,n))*ev([b+],[b])*ev([b+],[Q](i,j,k))+ev([b],[b],[b],[b],[Q](i,j,k))*ev([b+],[b+],[Q](l,m,n))+ev([b],[b],[b],[b],[Q](l,m,n))*ev([b+],[b+],[Q](i,j,k));

id ev([b+],[b+],[b],[b],[b],[b],[b],[Q](i?,j?,k?),[Q](l?,m?,n?))=+ev([b+],[b+],[b],[b],[b],[b],[b],[Q](i,j,k))*ev([Q](l,m,n))+ev([b+],[b+],[b],[b],[b],[b],[b],[Q](l,m,n))*ev([Q](i,j,k))-10*ev([b+],[b])*ev([b+],[b],[b],[b],[b],[Q](i,j,k))*ev([Q](l,m,n))-10*ev([b+],[b])*ev([b+],[b],[b],[b],[b],[Q](l,m,n))*ev([Q](i,j,k))+20*ev([b+],[b],[b],[b],[Q](i,j,k))*ev([b+],[b],[b],[Q](l,m,n))+20*ev([b+],[b],[b],[b],[Q](l,m,n))*ev([b+],[b],[b],[Q](i,j,k))+10*ev([b+],[b],[b],[b],[b],[Q](i,j,k))*ev([b+],[b],[Q](l,m,n))+10*ev([b+],[b],[b],[b],[b],[Q](l,m,n))*ev([b+],[b],[Q](i,j,k))+2*ev([b+],[b],[b],[b],[b],[b],[Q](i,j,k))*ev([b+],[Q](l,m,n))+2*ev([b+],[b],[b],[b],[b],[b],[Q](l,m,n))*ev([b+],[Q](i,j,k))+5*ev([b],[Q](i,j,k))*ev([b+],[b+],[b],[b],[b],[b],[Q](l,m,n))-40*ev([b],[Q](i,j,k))*ev([b+],[b])*ev([b+],[b],[b],[b],[Q](l,m,n))+5*ev([b],[Q](l,m,n))*ev([b+],[b+],[b],[b],[b],[b],[Q](i,j,k))-40*ev([b],[Q](l,m,n))*ev([b+],[b])*ev([b+],[b],[b],[b],[Q](i,j,k))+10*ev([b],[b],[Q](i,j,k))*ev([b+],[b+],[b],[b],[b],[Q](l,m,n))-60*ev([b],[b],[Q](i,j,k))*ev([b+],[b])*ev([b+],[b],[b],[Q](l,m,n))-30*ev([b],[b],[Q](i,j,k))*ev([b],[Q](l,m,n))*ev([b+],[b+],[b],[b])+120*ev([b],[b],[Q](i,j,k))*ev([b],[Q](l,m,n))*ev([b+],[b])^2+10*ev([b],[b],[Q](l,m,n))*ev([b+],[b+],[b],[b],[b],[Q](i,j,k))-60*ev([b],[b],[Q](l,m,n))*ev([b+],[b])*ev([b+],[b],[b],[Q](i,j,k))-30*ev([b],[b],[Q](l,m,n))*ev([b],[Q](i,j,k))*ev([b+],[b+],[b],[b])+120*ev([b],[b],[Q](l,m,n))*ev([b],[Q](i,j,k))*ev([b+],[b])^2-10*ev([b],[b],[b],[Q](i,j,k))*ev([b+],[b+],[b],[b])*ev([Q](l,m,n))+10*ev([b],[b],[b],[Q](i,j,k))*ev([b+],[b+],[b],[b],[Q](l,m,n))+40*ev([b],[b],[b],[Q](i,j,k))*ev([b+],[b])^2*ev([Q](l,m,n))-40*ev([b],[b],[b],[Q](i,j,k))*ev([b+],[b])*ev([b+],[b],[Q](l,m,n))-10*ev([b],[b],[b],[Q](l,m,n))*ev([b+],[b+],[b],[b])*ev([Q](i,j,k))+10*ev([b],[b],[b],[Q](l,m,n))*ev([b+],[b+],[b],[b],[Q](i,j,k))+40*ev([b],[b],[b],[Q](l,m,n))*ev([b+],[b])^2*ev([Q](i,j,k))-40*ev([b],[b],[b],[Q](l,m,n))*ev([b+],[b])*ev([b+],[b],[Q](i,j,k))+5*ev([b],[b],[b],[b],[Q](i,j,k))*ev([b+],[b+],[b],[Q](l,m,n))-10*ev([b],[b],[b],[b],[Q](i,j,k))*ev([b+],[b])*ev([b+],[Q](l,m,n))+5*ev([b],[b],[b],[b],[Q](l,m,n))*ev([b+],[b+],[b],[Q](i,j,k))-10*ev([b],[b],[b],[b],[Q](l,m,n))*ev([b+],[b])*ev([b+],[Q](i,j,k))+ev([b],[b],[b],[b],[b],[Q](i,j,k))*ev([b+],[b+],[Q](l,m,n))+ev([b],[b],[b],[b],[b],[Q](l,m,n))*ev([b+],[b+],[Q](i,j,k));
#endprocedure
